/* 
 * Swagger Petstore
 *
 * This is a sample Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/). 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: apiteam@swagger.io
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Business Term: Scheme Member Definition: Information about a Member of the Scheme. Purpose: To have enough information to be able to produce a Statement of Account indicating premium due.
    /// </summary>
    [DataContract]
        public partial class ValMemberChoice2 :  IEquatable<ValMemberChoice2>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValMemberChoice2" /> class.
        /// </summary>
        /// <param name="valLeavingDate">Business Term: Leaving Date Definition: The date the member left/is due to leave the scheme. Purpose: To identify those members that have left or are due to leave the scheme. To be able to calculate the benefit insured/premium payable in respect of the member/category..</param>
        public ValMemberChoice2(DateTime? valLeavingDate = default(DateTime?))
        {
            this.ValLeavingDate = valLeavingDate;
        }
        
        /// <summary>
        /// Business Term: Leaving Date Definition: The date the member left/is due to leave the scheme. Purpose: To identify those members that have left or are due to leave the scheme. To be able to calculate the benefit insured/premium payable in respect of the member/category.
        /// </summary>
        /// <value>Business Term: Leaving Date Definition: The date the member left/is due to leave the scheme. Purpose: To identify those members that have left or are due to leave the scheme. To be able to calculate the benefit insured/premium payable in respect of the member/category.</value>
        [DataMember(Name="val_leaving_date", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? ValLeavingDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ValMemberChoice2 {\n");
            sb.Append("  ValLeavingDate: ").Append(ValLeavingDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValMemberChoice2);
        }

        /// <summary>
        /// Returns true if ValMemberChoice2 instances are equal
        /// </summary>
        /// <param name="input">Instance of ValMemberChoice2 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValMemberChoice2 input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ValLeavingDate == input.ValLeavingDate ||
                    (this.ValLeavingDate != null &&
                    this.ValLeavingDate.Equals(input.ValLeavingDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ValLeavingDate != null)
                    hashCode = hashCode * 59 + this.ValLeavingDate.GetHashCode();
                return hashCode;
            }
        }

    }
}
